                PROGRAM

                MAP
                  AddFace (*CSTRING),NAME('_AddFace')
                  AddCharset (BYTE, <*CSTRING>),NAME('_AddCharset')

                  Main

                  MODULE('')
                    EnumFonts(<*CSTRING>),RAW,NAME('__EnumFonts')
                    EnumCharSets(*CSTRING),RAW,NAME('__EnumCharSets')
                  END
                END

LF_FACESIZE     EQUATE(32)

FontQ           QUEUE
Face              CSTRING(LF_FACESIZE + 1)
                END

CharsetQ        QUEUE
Name              CSTRING(2*LF_FACESIZE + 1)
N                 BYTE
                END

Dflt            CSTRING(2*LF_FACESIZE + 1)

  CODE
  Main

! =============================================================================

Main  PROCEDURE()

W    WINDOW('Fonts'),AT(,,303,227),FONT('MS Sans Serif',8,,FONT:regular),IMM,SYSTEM,GRAY,AUTO
       LIST,AT(11,15,136,175),USE(?FontList),VSCROLL,FORMAT('128L(1)~Fonts~@S32@'),FROM(FontQ)
       LIST,AT(153,15,136,175),USE(?SetList),VSCROLL,FORMAT('160L(1)~Charsets~@S64@'),FROM(CharsetQ)
       BUTTON('&Close'),AT(233,203,57,14),USE(?Close),STD(STD:Close)
     END

  CODE
  EnumFonts();

  OPEN (W)
  SELECT (?FontList, 1)
  SELECT (?FontList)

  Dflt = 'Arial'
  EnumCharSets (Dflt)

  ACCEPT
    IF  FIELD() = ?FontList  AND  EVENT() = EVENT:NewSelection
      FREE (CharsetQ)

      GET (FontQ, CHOICE (?FontList))
      EnumCharSets (FontQ.Face)

      DISPLAY
    END
  END

  CLOSE (W)

  FREE (FontQ)
  FREE (CharsetQ)

  RETURN

! =============================================================================

AddFace  PROCEDURE (*CSTRING name)

  CODE
  FontQ.Face = name
  ADD (FontQ, FontQ.Face)
  RETURN

AddCharset  PROCEDURE (BYTE set, <*CSTRING extra>)

  CODE
  CharsetQ.N = set

  CASE set
  OF   0
    CharsetQ.Name = 'Western'
  OF   1
    CharsetQ.Name = 'Default'
  OF   2
    CharsetQ.Name = 'Symbol'
  OF  77
    CharsetQ.Name = 'Mac'
  OF 128
    CharsetQ.Name = 'Japanese (Shift-JIS)'
  OF 129
    CharsetQ.Name = 'Corean (Hangul)'
  OF 130
    CharsetQ.Name = 'Joha B'
  OF 134
    CharsetQ.Name = 'Chinese Simplified (GB2312)'
  OF 136
    CharsetQ.Name = 'Chinese Traditional (Big5)'
  OF 161
    CharsetQ.Name = 'Greek'
  OF 162
    CharsetQ.Name = 'Turkish'
  OF 177
    CharsetQ.Name = 'Hebrew'
  OF 178
    CharsetQ.Name = 'Arabic'
  OF 186
    CharsetQ.Name = 'Baltic'
  OF 204
    CharsetQ.Name = 'Cyrillic'
  OF 222
    CharsetQ.Name = 'Thai'
  OF 238
    CharsetQ.Name = 'Central European'
  OF 255
    CharsetQ.Name = 'OEM'
  ELSE
    CharsetQ.Name = 'Charset #' & set
  END

  IF  NOT OMITTED (2)
    CharsetQ.Name = CharsetQ.Name & ' - ' & extra
  END

  GET (CharsetQ, CharsetQ.N)

  IF  ERRORCODE()
    ADD (CharsetQ, CharsetQ.N)
  END
  RETURN

