#include "windows.h"

extern "C" void AddFace (unsigned, char *);
extern "C" void AddCharset (BYTE, unsigned, char *);

// ============================================================================

int CALLBACK EnumFamiliesProc (ENUMLOGFONT * _elf,
                               NEWTEXTMETRIC *,
                               int, LPARAM)
{
  char * _face = _elf->elfLogFont.lfFaceName;

  AddFace (LF_FACESIZE, _face);
  return 1;
};

int CALLBACK EnumCharsetsProc (ENUMLOGFONT * _elf,
                               NEWTEXTMETRIC *,
                               int, LPARAM)
{

  BYTE charset = _elf->elfLogFont.lfCharSet;

#if _WIN32

  ENUMLOGFONTEX * lf = (ENUMLOGFONTEX *) _elf;

  AddCharset (charset, LF_FACESIZE, (char *) lf->elfScript);

#else

  AddCharset (charset, LF_FACESIZE, (char *) 0);

#endif

  return 1;
};

// ============================================================================

extern "C" void _EnumFonts (char * family)
{
  HDC hDC = GetDC (0);

#if _WIN32
  EnumFontFamilies (hDC, family, (ENUMFONTFAMPROC) &EnumFamiliesProc, 0);
#else
  EnumFontFamilies (hDC, family, (FONTENUMPROC) &EnumFamiliesProc, 0);
#endif

  ReleaseDC (0, hDC);
};

extern "C" void _EnumCharsets (char * face)
{
  HDC hDC = GetDC (0);

#if _WIN32

  LOGFONT lf;

  lf.lfCharSet = DEFAULT_CHARSET;

  if (face)
    lstrcpy (lf.lfFaceName, face);
  else
    *lf.lfFaceName = '\0';

  EnumFontFamiliesEx (hDC, &lf, (FONTENUMPROC) &EnumCharsetsProc, 0, 0);

#else

  EnumFontFamilies (hDC, face, (FONTENUMPROC) &EnumCharsetsProc, 0);

#endif

  ReleaseDC (0, hDC);
};